property debug_me : true

property script_author : "Jonathan Nathan"
property script_name : "Drop File Typer"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:Drop%20File%20Typer"

property quitting : false
property allow_quitting : false

property stop_progress : false
property first_run : true

property file_type : "TEXT"
property creator_type : "????"

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	set allow_quitting to true
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	my quit_prep()
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
			tell image view 1 to register drag types {"file names"}
		end tell
		my set_codes()
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & script_release_date)
			set contents of text field "copyright" to (script_copyright)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		my quit_prep()
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "stop_progress" then
		set my stop_progress to false
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	end if
end clicked

on action the_object
	set object_name to name of the_object as Unicode text
	my update_status("action " & object_name)
end action

on drop the_object drag info drag_info
	set data_types to types of pasteboard of drag_info
	if "file names" is in data_types then
		set dropped_items to {}
		set preferred type of pasteboard of drag_info to localized string "file names"
		set dropped_items to contents of pasteboard of drag_info
	end if
	my update_dropped_items(dropped_items)
	set preferred type of pasteboard of drag_info to ""
	return true
end drop

on conclude drop the_object drag info drag_info
	--do nothing
end conclude drop

on update_dropped_items(dropped_items)
	my get_codes()
	repeat with This_Item in dropped_items
		try
			set This_Item to (contents of This_Item as Unicode text)
			my update_status("updating " & This_Item)
			set This_Item to (((This_Item as POSIX file) as alias) as Unicode text)
			set the_script to "ignoring application responses" & return & 
				"	try" & return & 
				"		tell application \"Finder\"" & return & 
				"			set file type of file \"" & This_Item & "\" to \"" & (file_type as Unicode text) & "\"" & return & 
				"			set creator type of file \"" & This_Item & "\" to \"" & (creator_type as Unicode text) & "\"" & return & 
				"		end tell" & return & 
				"	end try" & return & 
				"end ignoring" & return
			run script the_script
			my update_status("finished updating " & (This_Item as Unicode text) & " to creator_type: " & creator_type & " file_type: " & file_type)
		on error the_error
			my update_status(the_error)
		end try
	end repeat
end update_dropped_items

on get_codes()
	tell window "main"
		set file_type to contents of text field "file_type"
		set creator_type to contents of text field "creator_type"
	end tell
end get_codes

on set_codes()
	tell window "main"
		set contents of text field "file_type" to file_type
		set contents of text field "creator_type" to creator_type
	end tell
end set_codes

on quit_prep()
	set panel_wins to name of (windows whose class = panel)
	repeat with i from 1 to (length of panel_wins)
		try
			close panel window (item i of panel_wins)
		end try
	end repeat
	my get_codes()
	my write_settings()
	set quitting to true
end quit_prep

on progress_show(super_message, the_message)
	set stop_progress to true
	tell window "progress"
		set indeterminate of progress indicator "progress" to true
		set uses threaded animation of progress indicator "progress" to true
		tell progress indicator "progress" to start
		set contents of text field "progress_label_super" to super_message
		set contents of text field "progress_label" to the_message
		update
	end tell
	if visible of window "progress" = false then display window "progress" attached to window "main"
end progress_show

on progress_update(iteration, total_count, super_message, the_message)
	tell window "progress"
		if iteration = 1 then
			tell progress indicator "progress" to stop
			set indeterminate of progress indicator "progress" to false
		end if
		set contents of text field "progress_label_super" to super_message
		set contents of text field "progress_label" to the_message
		set maximum value of progress indicator "progress" to total_count
		set content of progress indicator "progress" to iteration
		update
	end tell
end progress_update

on progress_hide()
	close panel window "progress"
	tell window "progress"
		set contents of text field "progress_label_super" to ""
		set contents of text field "progress_label" to ""
		set content of progress indicator "progress" to 0
		tell progress indicator "progress" to stop
		set indeterminate of progress indicator "progress" to false
		update
	end tell
end progress_hide

on display_error(the_title, the_error)
	activate
	beep
	my update_status("Error: " & the_error)
	display alert the_title as critical message the_error default button "OK" attached to window "main"
end display_error

on display_warning(the_warning, the_buttons, default_button)
	activate
	beep
	return button returned of (display dialog the_warning buttons the_buttons default button default_button with icon 2)
end display_warning

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"first_run", contents:first_run}
		make new default entry at end of default entries with properties {name:"file_type", contents:file_type}
		make new default entry at end of default entries with properties {name:"creator_type", contents:creator_type}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set first_run to contents of default entry "first_run"
		set file_type to contents of default entry "file_type"
		set creator_type to contents of default entry "creator_type"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "first_run" to first_run
		set contents of default entry "file_type" to file_type
		set contents of default entry "creator_type" to creator_type
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status